=== debian/changelog ===
openal-soft (1:1.24.2-2) unstable; urgency=medium

  * Team upload.
  * Review of d/copyright
  * Remove leftover CDBS rule

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Aug 2025 18:46:48 +0200

openal-soft (1:1.24.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.24.2

 -- Fabian Greffrath <fabian@debian.org>  Fri, 17 Jan 2025 10:58:19 +0100

openal-soft (1:1.24.1-2) unstable; urgency=medium

  * Team upload
  * Also disable SIMD code on i386 for the embedded pffft library

 -- Fabian Greffrath <fabian@debian.org>  Thu, 28 Nov 2024 12:13:06 +0100

openal-soft (1:1.24.1-1) unstable; urgency=medium

  * Team upload
  * Fix baseline violation on i386 (Closes: #995194)
  * New upstream version 1.24.1
  * Remove patches

 -- Fabian Greffrath <fabian@debian.org>  Thu, 28 Nov 2024 11:31:49 +0100

openal-soft (1:1.24.0-4) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Limit pipewire support only to Linux architectures

 -- Fabian Greffrath <fabian@debian.org>  Sat, 23 Nov 2024 23:26:17 +0100

openal-soft (1:1.24.0-3) unstable; urgency=medium

  * Team upload
  * Cherry-pick patch from upstream to check that AltiVec is enabled
    before using it (Closes: #1087831)
  * Cherry-pick patch from upstream to use separate 32-bit second and
    nanosecond atomics for the clock (Closes: #1087824)

 -- Fabian Greffrath <fabian@debian.org>  Fri, 22 Nov 2024 08:38:41 +0100

openal-soft (1:1.24.0-2) unstable; urgency=medium

  * Team upload
  * Cherry-pick patch to fix ppc64el build (Closes: #1087828)
  * Add debian/upstream/metadata

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 20 Nov 2024 11:38:25 -0500

openal-soft (1:1.24.0-1) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * remove retired uploader Gonéri Le Bouder

  [ Fabian Greffrath ]
  * New upstream version 1.24.0

 -- Fabian Greffrath <fabian@debian.org>  Mon, 18 Nov 2024 20:14:53 +0100
