=== debian/watch ===
version=4
https://github.com/kcat/openal-soft/tags \
https://github.com/kcat/openal-soft/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@
