## openal-soft 1.25.0

=== CMakeLists.txt ===
# CMake build file list for OpenAL

cmake_minimum_required(VERSION 3.13...3.31)
enable_testing()

if(APPLE)
    # The workaround for try_compile failing with code signing
    # since cmake-3.18.2, not required
    set(CMAKE_TRY_COMPILE_PLATFORM_VARIABLES
        ${CMAKE_TRY_COMPILE_PLATFORM_VARIABLES}
        "CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED"
        "CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED")
    set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED NO)
    set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED NO)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "iOS")
    # Fix compile failure with armv7 deployment target >= 11.0, xcode clang
    # will report:
    # error: invalid iOS deployment version '--target=armv7-apple-ios13.6',
    # iOS 10 is the maximum deployment target for 32-bit targets
    # If CMAKE_OSX_DEPLOYMENT_TARGET is not defined, cmake will choose latest
    # deployment target
    if("${CMAKE_OSX_ARCHITECTURES}" MATCHES ".*armv7.*")
        if(NOT DEFINED CMAKE_OSX_DEPLOYMENT_TARGET
            OR NOT CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS "11.0")
            message(STATUS "Forcing iOS deployment target to 10.0 for armv7")
            set(CMAKE_OSX_DEPLOYMENT_TARGET "10.0" CACHE STRING "Minimum OS X deployment version"
                FORCE)
        endif()
    endif()
elseif(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
    set(ALSOFT_UWP TRUE)
endif()

# Don't mistake macOS for unix
if(UNIX AND NOT ANDROID AND NOT APPLE AND NOT RISCOS AND NOT HAIKU)
  set(UNIX_ELF ON)
else()
  set(UNIX_ELF OFF)
endif()

project(OpenAL
    VERSION 1.25.0
    LANGUAGES C CXX)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()
if(NOT CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "" CACHE STRING
        "Library postfix for debug builds. Normally left blank."
        FORCE)
endif()

set(ALSOFT_STD_VERSION_PROPS
    # Require C++20.
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED TRUE
    # Prefer C17, but support earlier when necessary.
    C_STANDARD 17)

set(CMAKE_MODULE_PATH "${OpenAL_SOURCE_DIR}/cmake")

include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckCXXSymbolExists)
include(CheckLinkerFlag)
include(CheckStructHasMember)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

find_package(PkgConfig)
find_package(SDL3 QUIET)

option(ALSOFT_DLOPEN  "Check for the dlopen API for loading optional libs"  ON)
option(ALSOFT_DLOPEN_NOTES  "Record dlopen dependencies in .note.dlopen section"  ${UNIX_ELF})

option(ALSOFT_WERROR  "Treat compile warnings as errors"      OFF)

option(ALSOFT_UTILS "Build utility programs"  ON)
option(ALSOFT_NO_CONFIG_UTIL "Disable building the alsoft-config utility" OFF)

option(ALSOFT_EXAMPLES  "Build example programs"  ON)
option(ALSOFT_TESTS "Build test programs"  OFF)

option(ALSOFT_INSTALL "Install main library" ON)
option(ALSOFT_INSTALL_CONFIG "Install alsoft.conf sample configuration file" ON)
option(ALSOFT_INSTALL_HRTF_DATA "Install HRTF data files" ON)
option(ALSOFT_INSTALL_AMBDEC_PRESETS "Install AmbDec preset files" ON)
option(ALSOFT_INSTALL_EXAMPLES "Install example programs (alplay, alstream, ...)" ON)
option(ALSOFT_INSTALL_UTILS "Install utility programs (openal-info, alsoft-config, ...)" ON)
option(ALSOFT_UPDATE_BUILD_VERSION "Update git build version info" ON)

option(ALSOFT_EAX "Enable legacy EAX extensions" ${WIN32})

option(ALSOFT_SEARCH_INSTALL_DATADIR "Search the installation data directory" OFF)
if(ALSOFT_SEARCH_INSTALL_DATADIR)
    set(ALSOFT_INSTALL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR})
endif()

if(DEFINED SHARE_INSTALL_DIR)
    message(WARNING "SHARE_INSTALL_DIR is deprecated.  Use the variables provided by the GNUInstallDirs module instead")
    set(CMAKE_INSTALL_DATADIR "${SHARE_INSTALL_DIR}")
endif()

if(DEFINED LIB_SUFFIX)
    message(WARNING "LIB_SUFFIX is deprecated.  Use the variables provided by the GNUInstallDirs module instead")
endif()
if(DEFINED ALSOFT_CONFIG)
    message(WARNING "ALSOFT_CONFIG is deprecated. Use ALSOFT_INSTALL_CONFIG instead")
endif()
if(DEFINED ALSOFT_HRTF_DEFS)
    message(WARNING "ALSOFT_HRTF_DEFS is deprecated. Use ALSOFT_INSTALL_HRTF_DATA instead")
endif()
if(DEFINED ALSOFT_AMBDEC_PRESETS)
    message(WARNING "ALSOFT_AMBDEC_PRESETS is deprecated. Use ALSOFT_INSTALL_AMBDEC_PRESETS instead")
endif()

if(MSVC)
    option(FORCE_STATIC_VCRT "Force /MT for static VC runtimes" OFF)
    if(FORCE_STATIC_VCRT)
        if(CMAKE_VERSION VERSION_GREATER_EQUAL 15.0)
            set(ALSOFT_STD_VERSION_PROPS ${ALSOFT_STD_VERSION_PROPS}
                MSVC_RUNTIME_LIBRARY MultiThreaded$<$<CONFIG:Debug>:Debug>)
        else()
            foreach(flag_var
                CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
                CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
                CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
                CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
                if(${flag_var} MATCHES "/MD")
                    string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
                endif()
            endforeach(flag_var)
        endif()
    endif()
endif()

if(WIN32 AND MINGW AND CMAKE_SIZEOF_VOID_P MATCHES "4")
    # HACK: 32-bit MinGW defines __STDCPP_DEFAULT_NEW_ALIGNMENT__ to 16, while
    # its default operator new relies on the system/Windows malloc that only
    # guarantees 8-byte alignment, leading to structs that need 16-byte
    # alignment being misaligned. This switch overrides that to assume only
    # 8-byte alignment from the default operator new.
    add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:-faligned-new=8>")
endif()

# Setting ALSOFT_STL_HARDENING=None disables/minimizes STL hardening, doing
# only checks required by the standard (or can't be disabled at all). Should
# really only be used where maximum performance is critical and the extra
# safety can be sacrificed.
#
# ALSOFT_STL_HARDENING=Performance enables some STL hardening, checking for more
# significant issues that can also be done "fast", that's easier to optimize
# away when unneeded and/or not become a bottleneck. This is generally
# considered fine for production use, and is the default here.
#
# ALSOFT_STL_HARDENING=Debug enables even more STL hardening, which has a much
# higher runtime cost for less benefit. It's not intended for production use.
set(ALSOFT_STL_HARDENING "Performance" CACHE STRING
    "Specifies the level of C++ STL hardening. None, Performance, Debug")
if(ALSOFT_STL_HARDENING STREQUAL "Default")
    message(NOTICE "STL hardening option \"${ALSOFT_STL_HARDENING}\" deprecated, please set \"Performance\"")
    set(ALSOFT_STL_HARDENING "Performance" CACHE STRING
        "Specifies the level of C++ STL hardening. None, Performance, Debug" FORCE)
endif()

check_cxx_symbol_exists(__GLIBCXX__ "version" HAVE_LIBSTDCXX)
check_cxx_symbol_exists(_LIBCPP_VERSION "version" HAVE_LIBCXX)
check_cxx_symbol_exists(_MSVC_STL_UPDATE "version" HAVE_MSSTL)
set(HARDENING_LEVEL "Default")
if(NOT (ALSOFT_STL_HARDENING STREQUAL ""))
    if(HAVE_LIBSTDCXX)
        if(ALSOFT_STL_HARDENING STREQUAL "Debug")
            add_compile_definitions("_GLIBCXX_DEBUG=1")
            set(HARDENING_LEVEL "Debug")
        elseif(ALSOFT_STL_HARDENING STREQUAL "None")
            # TODO: Not sure how to fully disable STL hardening with libstdc++,
            # aside from not defining anything and using the compiler's
            # default. _GLIBCXX_NO_ASSERTIONS can explicitly disable the
            # hardening assertions, but not all STL debugging functionality.
            add_compile_definitions("_GLIBCXX_NO_ASSERTIONS=1")
            set(HARDENING_LEVEL "None")
        else()
            if(NOT (ALSOFT_STL_HARDENING STREQUAL "Performance"))
                message(NOTICE "Unsupported STL hardening option \"${ALSOFT_STL_HARDENING}\", using Performance")
            endif()
            add_compile_definitions("_GLIBCXX_ASSERTIONS=1")
            set(HARDENING_LEVEL "Performance")
        endif()
    elseif(HAVE_LIBCXX)
        if(ALSOFT_STL_HARDENING STREQUAL "Debug")
            add_compile_definitions("_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_DEBUG")
            set(HARDENING_LEVEL "Debug")
        elseif(ALSOFT_STL_HARDENING STREQUAL "None")
            add_compile_definitions("_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_NONE")
            set(HARDENING_LEVEL "None")
        else()
            if(NOT (ALSOFT_STL_HARDENING STREQUAL "Performance"))
                message(NOTICE "Unsupported STL hardening option \"${ALSOFT_STL_HARDENING}\", using Performance")
            endif()
            add_compile_definitions("_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_FAST")
            set(HARDENING_LEVEL "Performance")
        endif()
    elseif(HAVE_MSSTL)
        # MSVC doesn't seem to have anything more than an on/off switch for STL
        # hardening, so Debug and Performance are the same here.
        if(ALSOFT_STL_HARDENING STREQUAL "Debug")
            add_compile_definitions("_MSVC_STL_HARDENING=1")
            set(HARDENING_LEVEL "Enabled")
        elseif(ALSOFT_STL_HARDENING STREQUAL "None")
            add_compile_definitions("_MSVC_STL_HARDENING=0")
            set(HARDENING_LEVEL "None")
        else()
            if(NOT (ALSOFT_STL_HARDENING STREQUAL "Performance"))
                message(NOTICE "Unsupported STL hardening option \"${ALSOFT_STL_HARDENING}\", using Performance")
            endif()
            add_compile_definitions("_MSVC_STL_HARDENING=1")
            set(HARDENING_LEVEL "Enabled")
        endif()
    endif()
endif()

# Work out whether C++20 modules are supported. Currently only works with CMake
# 3.28+ and the Ninja or VS 17 2022 generator, along with GCC 15+, Clang 17+,
# or MSVC 14.34+. Unfortunately CMake doesn't provide any check to tell whether
# it supports modules with the given generator and compiler, so we have to do a
# check ourselves (which is far less inclusive and more pessimistic than what
# it can actually do, especially as CMake continues to update and improve).
option(ALSOFT_ENABLE_MODULES "Enable use of C++20 modules when supported" ON)
set(HAVE_CXXMODULES FALSE)
if(ALSOFT_ENABLE_MODULES)
    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.28 AND (CMAKE_GENERATOR STREQUAL "Ninja"
            OR CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022"))
        if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 17.0)
            OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 15.0)
            OR (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 14.34))
            message(STATUS "C++20 modules enabled using ${CMAKE_CXX_COMPILER_ID} compiler v${CMAKE_CXX_COMPILER_VERSION} (CMake ${CMAKE_VERSION}, ${CMAKE_GENERATOR} generator)")
            set(HAVE_CXXMODULES TRUE)
        else()
            message(NOTICE "C++20 modules not supported with ${CMAKE_CXX_COMPILER_ID} compiler v${CMAKE_CXX_COMPILER_VERSION}")
        endif()
    else()
        message(NOTICE "C++20 modules not supported with ${CMAKE_GENERATOR} on CMake ${CMAKE_VERSION}")
    endif()
endif()


add_subdirectory(fmt-11.2.0 EXCLUDE_FROM_ALL)


set(CPP_DEFS ) # C pre-processor, not C++
set(INC_PATHS )
set(C_FLAGS )
set(LINKER_FLAGS )
set(LINKER_FLAGS_DEBUG )
set(LINKER_FLAGS_RELEASE )
set(EXTRA_LIBS )

if(WIN32)
    set(CPP_DEFS ${CPP_DEFS} _WIN32 NOMINMAX WIN32_LEAN_AND_MEAN)
    if(MINGW)
        set(CPP_DEFS ${CPP_DEFS} __USE_MINGW_ANSI_STDIO)
    endif()
