=== debian/changelog ===
openal-soft (1:1.25.0-1) unstable; urgency=medium

  * Update debian/watch file to version 5
  * New upstream version 1.25.0
    + Builds fine with libsdl3-dev installed (Closes: #1111643)
  * Add myself to Uploaders
  * Update debian/copyright, fix license blurbs
  * Debian Bookworm requires SSE2 support in i386 base line, so drop
    explicitly disabling this instruction set
  * Add qt6-base-dev to Build-Depends, build and install alsoft-config
    (Closes: #1056255)
  * Remove redundant RRR: no
  * Stop manpages referring to non-existent Texinfo manuals
  * Add dh-sequence-dlopenlibdeps to Build-Depends, remove
    dh_shlibdeps quirk
  * Clean up and simplify debian/rules

 -- Fabian Greffrath <fabian@debian.org>  Tue, 23 Dec 2025 10:28:26 +0100
