=== debian/control ===
--- 
+++ 
@@ -5,8 +5,10 @@
  Bruno "Fuddl" Kleinert <fuddl@tauware.de>,
  Reinhard Tartler <siretart@tauware.de>,
  Bret Curtis <psi29a@gmail.com>,
+ Fabian Greffrath <fabian@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-dlopenlibdeps,
  cmake,
  libasound2-dev [linux-any],
  libdbus-1-dev [linux-any],
@@ -15,12 +17,12 @@
  libpulse-dev,
  libsndio-dev,
  portaudio19-dev,
+ qt6-base-dev,
 Standards-Version: 4.7.2
 Section: libs
 Vcs-Git: https://salsa.debian.org/games-team/openal-soft.git
 Vcs-Browser: https://salsa.debian.org/games-team/openal-soft
 Homepage: https://github.com/kcat/openal-soft
-Rules-Requires-Root: no
 X-Style: black
 
 Package: libopenal-dev
@@ -46,12 +48,13 @@
  ${misc:Pre-Depends},
 Depends:
  libopenal-data (= ${source:Version}),
+ ${dlopen:Depends},
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- ${shlibs:Recommends},
+ ${dlopen:Recommends},
 Suggests:
- ${shlibs:Suggests},
+ ${dlopen:Suggests},
 Description: Software implementation of the OpenAL audio API (shared library)
  OpenAL, the Open Audio Library, is a joint effort to create an open,
  vendor-neutral, cross-platform API for interactive, primarily spatialized
