=== debian/watch ===
Version: 5
Template: GitHub
Owner: kcat
Project: openal-soft
