## openal-soft 1.25.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
 endif()
 
 project(OpenAL
-    VERSION 1.25.0
+    VERSION 1.25.1
     LANGUAGES C CXX)
 
 if(NOT CMAKE_BUILD_TYPE)
