=== debian/changelog ===
openal-soft (1:1.25.1-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Merge from Debian unstable. Remaining changes:
    - Don't depend on qt6 on i386

 -- Fabian Greffrath <fabian@debian.org>  Fri, 06 Feb 2026 12:09:37 +0100

openal-soft (1:1.25.1-1) unstable; urgency=medium

  * New upstream version 1.25.1
  * Bump Standards-Version to 4.7.2, remove redundant Priority field
  * Update Debian packaging copyright year

 -- Fabian Greffrath <fabian@debian.org>  Fri, 23 Jan 2026 10:45:53 +0100

openal-soft (1:1.25.0-1ubuntu3) resolute; urgency=medium

  * Don't depend on qt6 on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 01 Jan 2026 11:15:30 +0100
