=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: openal-soft
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Bruno "Fuddl" Kleinert <fuddl@tauware.de>,
@@ -8,6 +7,7 @@
  Fabian Greffrath <fabian@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
+ dh-exec,
  dh-sequence-dlopenlibdeps,
  cmake,
  libasound2-dev [linux-any],
@@ -17,8 +17,8 @@
  libpulse-dev,
  libsndio-dev,
  portaudio19-dev,
- qt6-base-dev,
-Standards-Version: 4.7.2
+ qt6-base-dev [!i386],
+Standards-Version: 4.7.3
 Section: libs
 Vcs-Git: https://salsa.debian.org/games-team/openal-soft.git
 Vcs-Browser: https://salsa.debian.org/games-team/openal-soft
