=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,10 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DEB_CMAKE_OPTIONS = \
-		-DALSOFT_UTILS=ON \
-		-DALSOFT_EXAMPLES=OFF \
-		-DALSOFT_TESTS=OFF \
-		-DALSOFT_UPDATE_BUILD_VERSION=OFF
+	-DALSOFT_UTILS=ON \
+	-DALSOFT_EXAMPLES=OFF \
+	-DALSOFT_TESTS=OFF \
+	-DALSOFT_UPDATE_BUILD_VERSION=OFF
 
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
 DEB_CMAKE_OPTIONS += -DALSOFT_CPUEXT_SSE3=OFF
